1 # This shell scriplet is meant to be included by other shell scripts
2 # to set up some variables pointing at the normal git directories and
3 # a few helper shell functions.
5 # Source git-sh-i18n for gettext support.
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
12 # But we protect ourselves from such a user mistake nevertheless.
15 # Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and
16 # do not equate an unset IFS with IFS with the default, so here is
17 # an explicit SP HT LF.
21 git_broken_path_fix () {
32 case "$SANE_TOOL_PATH:$elem" in
33 (?*:/bin | ?*:/usr/bin)
34 path="$path$sep$SANE_TOOL_PATH"
50 die_with_status 1 "$@"
56 printf >&2 '%s\n' "$*"
63 if test -z "$GIT_QUIET"
69 if test -n "$OPTIONS_SPEC"; then
76 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
77 parseopt_extra="--keep-dashdash"
78 [ -n "$OPTIONS_STUCKLONG" ] &&
79 parseopt_extra="$parseopt_extra --stuck-long"
82 echo "$OPTIONS_SPEC" |
83 git rev-parse --parseopt $parseopt_extra -- "$@" ||
87 dashless=$(basename -- "$0" | sed -e 's/-/ /')
89 die "$(eval_gettext "usage: \$dashless \$USAGE")"
92 if [ -z "$LONG_USAGE" ]
94 LONG_USAGE="$(eval_gettext "usage: \$dashless \$USAGE")"
96 LONG_USAGE="$(eval_gettext "usage: \$dashless \$USAGE
108 # Set the name of the end-user facing command in the reflog when the
109 # script may update refs. When GIT_REFLOG_ACTION is already set, this
110 # will not overwrite it, so that a scripted Porcelain (e.g. "git
111 # rebase") can set it to its own name (e.g. "rebase") and then call
112 # another scripted Porcelain (e.g. "git am") and a call to this
113 # function in the latter will keep the name of the end-user facing
114 # program (e.g. "rebase") in GIT_REFLOG_ACTION, ensuring whatever it
115 # does will be record as actions done as part of the end-user facing
116 # operation (e.g. "rebase").
118 # NOTE NOTE NOTE: consequently, after assigning a specific message to
119 # GIT_REFLOG_ACTION when calling a "git" command to record a custom
120 # reflog message, do not leave that custom value in GIT_REFLOG_ACTION,
121 # after you are done. Other callers of "git" commands that rely on
122 # writing the default "program name" in reflog expect the variable to
123 # contain the value set by this function.
125 # To use a custom reflog message, do either one of these three:
127 # (a) use a single-shot export form:
128 # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" \
129 # git command-that-updates-a-ref
131 # (b) save the original away and restore:
132 # SAVED_ACTION=$GIT_REFLOG_ACTION
133 # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
134 # git command-that-updates-a-ref
135 # GIT_REFLOG_ACITON=$SAVED_ACTION
137 # (c) assign the variable in a subshell:
139 # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
140 # git command-that-updates-a-ref
142 set_reflog_action() {
143 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
145 GIT_REFLOG_ACTION="$*"
146 export GIT_REFLOG_ACTION
151 if test -z "${GIT_EDITOR:+set}"
153 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
156 eval "$GIT_EDITOR" '"$@"'
162 GIT_PAGER=$(git var GIT_PAGER)
170 eval "$GIT_PAGER" '"$@"'
174 GREP_OPTIONS= LC_ALL=C grep @@SANE_TEXT_GREP@@ "$@"
178 GREP_OPTIONS= LC_ALL=C egrep @@SANE_TEXT_GREP@@ "$@"
181 is_bare_repository () {
182 git rev-parse --is-bare-repository
186 cdup=$(git rev-parse --show-toplevel) &&
188 gettextln "Cannot chdir to \$cdup, the toplevel of the working tree" >&2
193 require_work_tree_exists () {
194 if test "z$(git rev-parse --is-bare-repository)" != zfalse
197 die "$(gettext "fatal: \$program_name cannot be used without a working tree.")"
201 require_work_tree () {
202 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true || {
204 die "$(gettext "fatal: \$program_name cannot be used without a working tree.")"
208 require_clean_work_tree () {
209 git rev-parse --verify HEAD >/dev/null || exit 1
210 git update-index -q --ignore-submodules --refresh
213 if ! git diff-files --quiet --ignore-submodules
218 gettextln "Cannot rebase: You have unstaged changes." >&2
221 gettextln "Cannot rewrite branches: You have unstaged changes." >&2
224 gettextln "Cannot pull with rebase: You have unstaged changes." >&2
227 eval_gettextln "Cannot \$action: You have unstaged changes." >&2
233 if ! git diff-index --cached --quiet --ignore-submodules HEAD --
240 gettextln "Cannot rebase: Your index contains uncommitted changes." >&2
243 gettextln "Cannot pull with rebase: Your index contains uncommitted changes." >&2
246 eval_gettextln "Cannot \$action: Your index contains uncommitted changes." >&2
250 gettextln "Additionally, your index contains uncommitted changes." >&2
257 test -n "$2" && echo "$2" >&2
262 # Generate a sed script to parse identities from a commit.
264 # Reads the commit from stdin, which should be in raw format (e.g., from
265 # cat-file or "--pretty=raw").
267 # The first argument specifies the ident line to parse (e.g., "author"), and
268 # the second specifies the environment variable to put it in (e.g., "AUTHOR"
269 # for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
271 pick_ident_script () {
280 s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
281 s/.*/GIT_${uid}_NAME='&'/p
284 s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
285 s/.*/GIT_${uid}_EMAIL='&'/p
288 s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
289 s/.*/GIT_${uid}_DATE='&'/p
296 # Create a pick-script as above and feed it to sed. Stdout is suitable for
298 parse_ident_from_commit () {
299 LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")"
302 # Parse the author from a commit given as an argument. Stdout is suitable for
303 # feeding to eval to set the usual GIT_* ident variables.
304 get_author_ident_from_commit () {
305 encoding=$(git config i18n.commitencoding || echo UTF-8)
306 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
307 parse_ident_from_commit author AUTHOR
310 # Clear repo-local GIT_* environment variables. Useful when switching to
311 # another repository (e.g. when entering a submodule). See also the env
312 # list in git_connect()
313 clear_local_git_env() {
314 unset $(git rev-parse --local-env-vars)
317 # Generate a virtual base file for a two-file merge. Uses git apply to
318 # remove lines from $1 that are not in $2, leaving only common lines.
319 create_virtual_base() {
321 @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add
324 # If we do not have enough common material, it is not
325 # worth trying two-file merge using common subsections.
326 expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1"
330 # Platform specific tweaks to work around some commands
333 # Windows has its own (incompatible) sort and find
340 # git sees Windows-style pwd
344 is_absolute_path () {
353 is_absolute_path () {
362 # Make sure we are in a valid repository of a vintage we understand,
363 # if we require to be in a git repository.
365 GIT_DIR=$(git rev-parse --git-dir) || exit
366 if [ -z "$SUBDIRECTORY_OK" ]
368 test -z "$(git rev-parse --show-cdup)" || {
370 gettextln "You need to run this command from the toplevel of the working tree." >&2
374 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
375 gettextln "Unable to determine absolute path of git directory" >&2
378 : "${GIT_OBJECT_DIRECTORY="$(git rev-parse --git-path objects)"}"
381 if test -z "$NONGIT_OK"
389 peeltmp=$(git rev-parse --verify "$1") &&
390 git rev-parse --verify "${peeltmp}^0"
393 git rev-parse --verify "${1}^0"